const CLASS_ID = Components.ID("{d8a3d730-6bbd-11dd-ad8b-0800200c9a66}");
const CLASS_NAME = "Annozilla startup";
const CONTRACT_ID = "@annozilla.mozdev.org/annozilla-startup;1";

/***********************************************************
class definition
***********************************************************/

function AnnozillaStartup() {
};

// class definition
AnnozillaStartup.prototype = {

  observe: function(subject,topic,data)
  {
    if (topic == "app-startup")
    {
        var oS = Components.classes["@mozilla.org/observer-service;1"].
           getService (Components.interfaces.nsIObserverService);
        oS.addObserver (this, "sessionstore-windows-restored", false);
    }
    else if (topic == "sessionstore-windows-restored")
    {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
        var win = wm.getMostRecentWindow("navigator:browser");
        var prefBranch = 
            Components.classes["@mozilla.org/preferences;1"].
               getService(Components.interfaces.nsIPrefService).
               getBranch("annozilla.");

        // Open the launcher page only if we haven't already run it, and
        // if there isn't a "creator" preference set (use this as a guide
        // to whether the prefs have been set up previously)
        if ( (! prefBranch.prefHasUserValue("wizard.run") || ! prefBranch.getBoolPref ("wizard.run")) &&
             (! prefBranch.prefHasUserValue("creator") || ! prefBranch.getCharPref ("creator") != ''))
        {
          // Open the launcher page as a new tab
          win.setTimeout (function () {
            var browser = win.getBrowser();
            browser.selectedTab =
              browser.addTab
                ("chrome://annozilla/content/prefs/wizard/launcher.xhtml", null);
          }, 100);
          prefBranch.setBoolPref ("wizard.run", true);
        }
    }
  },

  QueryInterface: function(aIID)
  {
    if (!aIID.equals(Components.interfaces.nsISupports) &&
        !aIID.equals(Components.interfaces.nsIObserver))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
};

var AnnozillaStartupFactory = {
  createInstance: function (aOuter, aIID)
  {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    return (new AnnozillaStartup()).QueryInterface(aIID);
  }
};

var AnnozillaStartupModule = {
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, 
        CONTRACT_ID, aFileSpec, aLocation, aType);
    
    var catMgr = Components.classes["@mozilla.org/categorymanager;1"].
         getService(Components.interfaces.nsICategoryManager);
    catMgr.addCategoryEntry("app-startup", CLASS_NAME, CONTRACT_ID, true, true);
    
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
    var catMgr = Components.classes["@mozilla.org/categorymanager;1"].
       getService(Components.interfaces.nsICategoryManager);
    catMgr.deleteCategoryEntry("app-startup", CLASS_NAME, true);
    
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
  },
  
  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return AnnozillaStartupFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return AnnozillaStartupModule; }
