
var gDS;

function validateRemoteServerConf ()
{
    var url = document.getElementById("remoteServer").value;
    if (!document.getElementById("remoteServer").value) {
        window.alert ("No server URL has been specified");
        return false;
    }
    return true;
}

function saveServerDetails (serverUrl) {

    // get the servers RDF file
    var file = getServersFile();

    // open the file to a datasource
    gDS = getDatasource (file); 

    // get the Bag in container
    var container = Components.classes["@mozilla.org/rdf/container;1"].createInstance();
    container = container.QueryInterface(Components.interfaces.nsIRDFContainer);

    // initialize the container to the root urn
    var containerRes = gRDF.GetResource(SERVERS_ROOT_URN);
    container.Init(gDS, containerRes);

    // if the server URL doesn't contain a //, prepend http
    if (serverUrl != "urn:localserver" && ! serverUrl.match(/\/\//) ) {
        serverUrl = "http://" + serverUrl;
    }

    // create a new li element for the new server URL
    var element = gRDF.GetResource(serverUrl);

    // check that the URL doesn't already exist
    if (container.IndexOf(element) == -1) {
        container.AppendElement(element);
    }

    // assert the literals for this server
    assertForResource(element, "user", "");
    assertForResource(element, "password", "");

    // flush the ds to disk.
    var remoteDS = gDS.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    remoteDS.Flush();
}

function storePrefs ()
{
    var serverType = document.getElementById("servertype").value;

    var serverUrl = (serverType == "local") ? LOCALSERVER_URL : document.getElementById("remoteServer").value;
    saveServerDetails(serverUrl);

    var prefBranch = 
        Components.classes["@mozilla.org/preferences;1"]
          .getService(Components.interfaces[Components.interfaces.nsIPref])
               .getBranch ("annozilla.");
    prefBranch.setBoolPref ("insertIcons", true);
    prefBranch.setBoolPref ("insertHighlight", true);
    prefBranch.setBoolPref ("loadInNewWindow", false);
    if (serverType == "local") {
        prefBranch.setCharPref ("autoLoadMulti", "always");
    } else {
        prefBranch.setCharPref ("autoLoadMulti", "never");
    }
    prefBranch.setCharPref
        ("creator",
         document.getElementById("realname").value);
    prefBranch.setCharPref ("defaultPostServer", serverUrl);

    return true;

}

function assertForResource(aResource, aPropertyString, aValueString)
{
    var valueProperty = gRDF.GetResource(SERVER_RDF(aPropertyString));
    var serverLiteral = gRDF.GetLiteral(aValueString);
    gDS.Assert(aResource, valueProperty, serverLiteral, true);
}

function wizardGoTo (pageid)
{
    document.getElementById('annozillaPrefsWizard').goTo(pageid); 
    return false;
}
